<template>
  <v-app>
    <Menu/>
    <v-layout row>
      <!-- Left sidebar -->
      <LeftSidebar/>
      <!-- / Left sidebar -->
      <v-flex xs12 sm8>
        <v-card>
          <v-list two-line>
            <v-subheader>
              Ваши записи
            </v-subheader>
            <template v-for="(item, index) in posts">
              <v-divider></v-divider>
              <v-list-tile
                :key="item.title"
                @click="route('/edit/post/' + item.id)"
              >
                <v-list-tile-content>
                  <v-list-tile-title v-html="item.title"></v-list-tile-title>
                  <v-list-tile-sub-title v-text="item.is_approved"></v-list-tile-sub-title>
                  <v-list-tile-sub-title v-html="item.text"></v-list-tile-sub-title>
                </v-list-tile-content>
              </v-list-tile>
            </template>
          </v-list>
        </v-card>
      </v-flex>
    </v-layout>
  </v-app>
</template>

<script>
  import Editor from "@servicestack/editor";
  import Menu from '../components/Menu'
  import LeftSidebar from '../components/LeftSidebar'
  import axios from 'axios'

  export default {
    beforeRouteEnter(to, from, next) {
      // check user permissions
      next(vm => {
        let userProfile = JSON.parse(localStorage.getItem('profileStorage'))
        if (userProfile === null) {
          vm.$router.push('/login')
        }
        console.log('Logged in')
      })
    },
    components: {
      Menu,
      LeftSidebar,
      Editor
    },
    data() {
      return {
        posts: [],
        userProfile: null,
      }
    },
    created() {
      this.getUserProfile()
    },
    methods: {
      getUserProfile() {
        this.$store.dispatch('getProfile')
          .then(() => {
            let profile = localStorage.getItem('profileStorage')
            this.userProfile = JSON.parse(profile)
            this.getAuthorPosts()
          })
      },
      route(path) {
        this.$router.push(path)
      },
      getAuthorPosts() {
        return axios.get('/api/posts?author=' + this.userProfile.id)
          .then(response => {
            this.posts = response.data
          })
          .catch(e => {
            console.log(e)
          })
      },
    }
  }
</script>
